
<!DOCTYPE HTML>
<html>
  <head>

    <title>DashGL.com</title>

    <meta charset="utf-8" />
    <meta name="viewport"
      content="width=device-width,initial-scale=1.0,user-scalable=no">
    <meta name="description" content="Tutortials for Linux programming using
      GTK, C, and OpenGL" />
    <meta name="keywords" content="Linux,C,OpenGL,Tutorial,GTK">
    <meta name="author" content="Kion">

    <link rel="shortcut icon" href="/img/favicon.png">
    <link rel="stylesheet" type="text/css" href="/css/layout.css" />
  </head>
  <body>

    <div class="title">
      <a href="/Information?file=Mascot"><img
          src="/img/others_20171117_dashgl_dash_cropped_icon.png" /></a>
    </div>

    <header>

      <table>
        <th>
          <h1><a href="index.php">DashGL</a></h1>
        </th>
        <td></td>

        <td><a href='/Brickout' class='selected'>Brickout</a></td>
        <td><a href='/Invaders'>Invaders</a></td>
        <td><a href='/Astroids'>Astroids</a></td>
        <td><a href='/Information'>Information</a></td>

      </table>
    </header>

    <nav id="nav">

      <li><a href='/Brickout' class='selected'>Brickout</a></li>
      <li><a href='/Invaders'>Invaders</a></li>
      <li><a href='/Astroids'>Astroids</a></li>
      <li><a href='/Information'>Information</a></li>

    </nav>

    <section>

      <article>

        <table class='author'>
          <tr>
            <td>By Kion</td>
            <td>Sept. 30, 2017</td>
          </tr>
          <tr>
            <td><a
                href="https://github.com/kion-dgl/DashGL-GTK-Brickout-Tutorial/tree/master/13_Keydown_Callbacks">View
                Source On Github</a></td>
            <td></td>
          </tr>
        </table>

        <img src="/img/bricks_013.png" width="646" height="512" />

        <p>
          Time to handle some user input. We define callback events
          for keydown and keyup to be able to move the paddle.
        </p>

        <pre data-file="main.c">
#include &lt;epoxy/gl.h&gt;
#include &lt;epoxy/glx.h&gt;
#include &lt;gtk/gtk.h&gt;
#include &lt;math.h&gt;
#include "DashGL/dashgl.h"

#define WIDTH 640.0f
#define HEIGHT 480.0f

static void on_realize(GtkGLArea *area);
static void on_render(GtkGLArea *area, GdkGLContext *context);
static gboolean on_idle(gpointer data);
static gboolean on_keydown(GtkWidget *widget, GdkEventKey *event);
static gboolean on_keyup(GtkWidget *widget, GdkEventKey *event);

struct {
	float dx, dy;
	vec3 pos;
	vec3 color;
	mat4 mvp;
	GLuint vbo;
} ball;

struct {
	float dx;
	vec3 pos;
	vec3 color;
	mat4 mvp;
	GLuint vbo;
	<span>gboolean key_left;
	gboolean key_right;</span>
} paddle;

GLuint program;
GLuint vao;
GLint attribute_coord2d;
GLint uniform_mvp, uniform_color;

int main(int argc, char *argv[]) {

	GtkWidget *window;
	GtkWidget *glArea;

	gtk_init(&argc, &argv);

	// Initialize Window

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), "Brickout Tutorial");
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
	gtk_window_set_default_size(GTK_WINDOW(window), 640, 480);
	gtk_window_set_type_hint(GTK_WINDOW(window), GDK_WINDOW_TYPE_HINT_UTILITY);
	g_signal_connect(window, "destroy", G_CALLBACK(gtk_main_quit), NULL);
	g_signal_connect(window, "key-press-event", G_CALLBACK(on_keydown), NULL);
	g_signal_connect(window, "key-release-event", G_CALLBACK(on_keyup), NULL);

	// Initialize GTK GL Area

	glArea = gtk_gl_area_new();
	gtk_widget_set_vexpand(glArea, TRUE);
	gtk_widget_set_hexpand(glArea, TRUE);
	g_signal_connect(glArea, "realize", G_CALLBACK(on_realize), NULL);
	g_signal_connect(glArea, "render", G_CALLBACK(on_render), NULL);
	gtk_container_add(GTK_CONTAINER(window), glArea);

	// Show widgets

	gtk_widget_show_all(window);
	gtk_main();

	return 0;

}

static void on_realize(GtkGLArea *area) {

	// Debug Message

	g_print("on realize\n");

	gtk_gl_area_make_current(area);
	if(gtk_gl_area_get_error(area) != NULL) {
		fprintf(stderr, "Unknown error\n");
		return;
	}

	const GLubyte *renderer = glGetString(GL_RENDER);
	const GLubyte *version = glGetString(GL_VERSION);
	const GLubyte *shader = glGetString(GL_SHADING_LANGUAGE_VERSION);

	printf("Shader %s\n", shader);
	printf("Renderer: %s\n", renderer);
	printf("OpenGL version supported %s\n", version);

	glClearColor(1.0f, 1.0f, 1.0f, 1.0f);

	glGenVertexArrays(1, &vao);
	glBindVertexArray(vao);

	int i;
	float angle, nextAngle;
	int num_segments = 99;

	GLfloat circle_vertices[6 * 100];
	
	for(i = 0; i <num_segments; i++) {

		angle = i * 2.0f * M_PI / (num_segments - 1);
		nextAngle = (i+1) * 2.0f * M_PI / (num_segments - 1);

		circle_vertices[i*6 + 0] = cos(angle) * 18;
		circle_vertices[i*6 + 1] = sin(angle) * 18;

		circle_vertices[i*6 + 2] = cos(nextAngle) * 18;
		circle_vertices[i*6 + 3] = sin(nextAngle) * 18;

		circle_vertices[i*6 + 4] = 0.0f;
		circle_vertices[i*6 + 5] = 0.0f;

	}

	glGenBuffers(1, &ball.vbo);
	glBindBuffer(GL_ARRAY_BUFFER, ball.vbo);
	glBufferData(
		GL_ARRAY_BUFFER,
		sizeof(circle_vertices),
		circle_vertices,
		GL_STATIC_DRAW
	);

	GLfloat paddle_vertices[] = {
		-50.0f, -7.0f,
		-50.0f,  7.0f,
		 50.0f,  7.0f,
		 50.0f,  7.0f,
		 50.0f, -7.0f,
		-50.0f, -7.0f
	};

	glGenBuffers(1, &paddle.vbo);
	glBindBuffer(GL_ARRAY_BUFFER, paddle.vbo);
	glBufferData(
		GL_ARRAY_BUFFER,
		sizeof(paddle_vertices),
		paddle_vertices,
		GL_STATIC_DRAW
	);

	glVertexAttribPointer(0, 2, GL_FLOAT, GL_FALSE, 0, 0);
	glEnableVertexAttribArray(0);
	glDisableVertexAttribArray(0);
	
	const char *vs = "shader/vertex.glsl";
	const char *fs = "shader/fragment.glsl";

	program = shader_load_program(vs, fs);

	const char *attribute_name = "coord2d";
	attribute_coord2d = glGetAttribLocation(program, attribute_name);
	if(attribute_coord2d == -1) {
		fprintf(stderr, "Could not bind attribute %s\n", attribute_name);
		return;
	}

	const char *uniform_name = "orthograph";
	GLint uniform_ortho = glGetUniformLocation(program, uniform_name);
	if(uniform_ortho == -1) {
		fprintf(stderr, "Could not bind uniform %s\n", uniform_name);
		return;
	}
	
	uniform_name = "mvp";
	uniform_mvp = glGetUniformLocation(program, uniform_name);
	if(uniform_mvp == -1) {
		fprintf(stderr, "Could not bind uniform %s\n", uniform_name);
		return;
	}

	uniform_name = "color";
	uniform_color = glGetUniformLocation(program, uniform_name);
	if(uniform_color == -1) {
		fprintf(stderr, "Could not bind uniform %s\n", uniform_name);
		return;
	}

	glUseProgram(program);

	mat4 orthograph;
	mat4_orthagonal(WIDTH, HEIGHT, orthograph);

	glUniformMatrix4fv(uniform_ortho, 1, GL_FALSE, orthograph);
	g_timeout_add(20, on_idle, (void*)area);
	
	ball.dx = 2.0f;
	ball.dy = 3.0f;
	ball.pos[0] = 50.0f;
	ball.pos[1] = 50.0f;
	ball.pos[2] = 0.0f;
	ball.color[0] = 0.0f;
	ball.color[1] = 0.0f;
	ball.color[2] = 1.0f;

	paddle.dx = 2.0f;
	paddle.pos[0] = WIDTH / 2.0f;
	paddle.pos[1] = 20.0f;
	paddle.pos[2] = 0.0f;
	paddle.color[0] = 0.0f;
	paddle.color[1] = 0.0f;
	paddle.color[2] = 0.0f;
	
	<span>paddle.key_left = FALSE;
	paddle.key_right = FALSE;</span>
}

static void on_render(GtkGLArea *area, GdkGLContext *context) {

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	mat4_translate(ball.pos, ball.mvp);
	glUniformMatrix4fv(uniform_mvp, 1, GL_FALSE, ball.mvp);
	glUniform3fv(uniform_color, 1, ball.color);

	glBindVertexArray(vao);
	glEnableVertexAttribArray(attribute_coord2d);

	glBindBuffer(GL_ARRAY_BUFFER, ball.vbo);
	glVertexAttribPointer(
		attribute_coord2d,
		2,
		GL_FLOAT,
		GL_FALSE,
		0,
		0
	);
	glDrawArrays(GL_TRIANGLES, 0, 3 * 100);

	mat4_translate(paddle.pos, paddle.mvp);
	glUniformMatrix4fv(uniform_mvp, 1, GL_FALSE, paddle.mvp);
	glUniform3fv(uniform_color, 1, paddle.color);

	glBindBuffer(GL_ARRAY_BUFFER, paddle.vbo);
	glVertexAttribPointer(
		attribute_coord2d,
		2,
		GL_FLOAT,
		GL_FALSE,
		0,
		0
	);
	glDrawArrays(GL_TRIANGLES, 0, 3 * 2);
	glDisableVertexAttribArray(attribute_coord2d);

}

static gboolean on_idle(gpointer data) {

	ball.pos[0] += ball.dx;
	ball.pos[1] += ball.dy;

	if(ball.pos[0] > WIDTH) {
		ball.pos[0] = WIDTH;
		ball.dx *= -1;
	} else if(ball.pos[0] <0) {
		ball.pos[0] = 0;
		ball.dx *= -1;
	}

	if(ball.pos[1] > HEIGHT) {
		ball.pos[1] = HEIGHT;
		ball.dy *= -1;
	} else if(ball.pos[1] <0) {
		ball.pos[1] = 0;
		ball.dy *= -1;
	}

	<span>if(paddle.key_left) {
		paddle.pos[0] -= paddle.dx;
	}

	if(paddle.key_right) {
		paddle.pos[0] += paddle.dx;
	}

	if(paddle.pos[0] <0) {
		paddle.pos[0] = 0.0f;
	} else if(paddle.pos[0] > WIDTH) {
		paddle.pos[0] = WIDTH;
	}</span>

	gtk_widget_queue_draw(GTK_WIDGET(data));
	return TRUE;

}

<span>static gboolean on_keydown(GtkWidget *widget, GdkEventKey *event) {

	switch(event->keyval) {
		case GDK_KEY_Left:
			paddle.key_left = TRUE;
		break;
		case GDK_KEY_Right:
			paddle.key_right = TRUE;
		break;
	}

}

static gboolean on_keyup(GtkWidget *widget, GdkEventKey *event) {

	switch(event->keyval) {
		case GDK_KEY_Left:
			paddle.key_left = FALSE;
		break;
		case GDK_KEY_Right:
			paddle.key_right = FALSE;
		break;
	}

}</span>
</pre>

            <p>
              Compile with:
            </p>

            <pre>$ gcc -c -o DashGL/dashgl.o DashGL/dashgl.c -lepoxy -lpng -lm
$ gcc `pkg-config --cflags gtk+-3.0` main.c DashGL/dashgl.o `pkg-config --libs gtk+-3.0` \
-lepoxy -lm -lpng</pre>

            <p>
              Run with:
            </p>

            <pre>$ ./a.out</pre>

          </article>

        </section>

        <aside>
          <ul>

            <li><a href='/Brickout/Introduction'>Introduction</a></li>
            <li><a href='/Brickout/Open_a_Window'>Open a Window</a></li>
            <li><a href='/Brickout/Draw_a_Triangle'>Draw a Triangle</a></li>
            <li><a href='/Brickout/Separate_Shaders'>Separate
                Shaders</a></li>
            <li><a href='/Brickout/Shader_Program'>Shader Program</a></li>
            <li><a href='/Brickout/Orthagonal_Coordinates'>Orthagonal
                Coordinates</a></li>
            <li><a href='/Brickout/Draw_a_Ball'>Draw a Ball</a></li>
            <li><a href='/Brickout/Set_Ball_Position'>Set Ball
                Position</a></li>
            <li><a href='/Brickout/Move_a_Ball'>Move a Ball</a></li>
            <li><a href='/Brickout/Bounce_a_Ball'>Bounce a Ball</a></li>
            <li><a href='/Brickout/Define_Ball_Struct'>Define Ball
                Struct</a></li>
            <li><a href='/Brickout/Draw_a_Paddle'>Draw a Paddle</a></li>
            <li><a href='/Brickout/Paddle_Uniform_Color'>Paddle
                Uniform Color</a></li>
            <li><a class='selected'
                href='/Brickout/Keydown_Callbacks'>Keydown Callbacks</a></li>
            <li><a href='/Brickout/Paddle_Hit_Detection'>Paddle Hit
                Detection</a></li>
            <li><a href='/Brickout/Draw_Row_of_Bricks'>Draw Row of
                Bricks</a></li>
            <li><a href='/Brickout/Draw_Grid_of_Bricks'>Draw Grid of
                Bricks</a></li>
            <li><a href='/Brickout/Break_Some_Bricks'>Break Some
                Bricks</a></li>

          </ul>
        </aside>

        <footer>

          <table>
            <tr>
              <td><a href='/Brickout/Paddle_Uniform_Color'>&lt;&lt;
                  Prev<br>Paddle Uniform Color</a></td><td></td><td><a
                  href='/Brickout/Paddle_Hit_Detection'>Next
                  &gt;&gt;<br>Paddle Hit Detection</a></td> </tr>
          </table>

          Copyright &copy; 2017 DashGL Project

        </footer>

      </body>

    </html>
